;*******************************************************************

Include "xors3d.bb"


xGraphics3D 800, 600, 32, False, True

xHidePointer()

camera = xCreateCamera()

xPositionEntity camera, 0, 0, -10

cube = xCreateCube()

xMoveMouse xGraphicsWidth() / 2, xGraphicsHeight() / 2
mousespeed#       = 0.5 
camerasmoothness# = 4.5

light = xCreateLight()
xRotateEntity light, 45, 0, 0

effect = xLoadFXFile("media\simple.fx")

xSetEntityEffect cube, effect
xSetEffectTechnique cube, "Diffuse"

xSetEffectTexture cube,	"Stex1",xLoadTexture("media\grass1.jpg")
xSetEffectTexture cube,	"Stex2",xLoadTexture("media\rock1b.jpg")
xSetEffectTexture cube,	"Stex3",xLoadTexture("media\detailmap.jpg")
xSetEffectTexture cube,	"diffuseTexture",xLoadTexture("media\splat.png")
While Not xKeyDown(KEY_ESCAPE)
	
	If xKeyDown(KEY_W) Then xMoveEntity camera,  0,  0,  1
	If xKeyDown(KEY_S) Then xMoveEntity camera,  0,  0, -1
	If xKeyDown(KEY_A) Then xMoveEntity camera, -1,  0,  0
	If xKeyDown(KEY_D) Then xMoveEntity camera,  1,  0,  0
	mxs# = CurveValue(xMouseXSpeed() * mousespeed, mxs, camerasmoothness)
	mys# = CurveValue(xMouseYSpeed() * mousespeed, mys, camerasmoothness)
	camxa# = camxa - mxs Mod 360
	camya# = camya + mys
	If camya < -89 Then camya = -89
	If camya >  89 Then camya =  89
	xMoveMouse xGraphicsWidth() / 2, xGraphicsHeight() / 2
	xRotateEntity camera, camya, camxa, 0.0
	
	;xTurnEntity cube, 0, 1, 0
	xRenderWorld()
	xFlip()
	
Wend

Function CurveValue#(newvalue#, oldvalue#, increments)
	If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments 
	If increments <= 1 Then oldvalue# = newvalue# 
	Return oldvalue# 
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D